;=====================================================================
;                               viewexpr.asm
;=====================================================================

color		equ	0

	include "doorsos.h"
	xdef		_ti89
	xdef		_ti92plus
 	xdef 		_main
	xdef		_comment

;---------------------------------------------------------------------

_main:
	bra.s	after

handle	dc.w	0

after
	move.w	handle(pc),d7
	tst.w	d7
	bne	cont
	rts		; bye bye
cont:
;-----------Ca y est on a l'handle de l'EXPR dans d7-------------------

	move.l		doorsos::top_estack,d3	; sauve l'estack
	move.l		a7,a6
	move.w		#$300,-(a7)			;le flag de la window
	pea		rect(Pc)			;taille de la window
	push.l		#window			;endroit o on va storer la window
	jsr    	doorsos::WinOpen
	tst.b		d0
	beq		w_err

	move.w   	d7,-(a7)			; l'EXPR maintenant !
	jsr    	doorsos::HToESI		;gnre l'ESI
	move.l		a0,a2
	push.b		(a0)				; pushes *ESI
	jsr		doorsos::QSysProtected
	tst.w		d0
	bne		quit

	clr.w		-(a7)
	move.l		a2,-(a7)			
	jsr    	doorsos::Parse2DExpr		;construit l'image
	move.l		a0,a2				;sauve le resultat ed parse2d
	pea		bottom(pc)
	pea		top(pc)
	pea		width(pc)
	push.l		a2
	jsr		doorsos::Parms2D

	move.w		bottom,y
	clr.w		x

loop:

	push.l		#window
	jsr		doorsos::WinClr

	move.w		y,-(a7)
	move.w		x,-(a7)
	move.l		#window,-(a7)
	move.l		a2,-(a7)
	jsr    	doorsos::Print2DExpr		;affiche en PrettyPrint

	lea		16(a7),a7		

	clr.b		what_to_do

	tst.w		x
	bne		left_arrow

after_test_left_arrow:
	move.w		bottom,d0
	cmp.w		y,d0
	bne		up_arrow

after_test_up_arrow:
	move.w		x,d0
	add.w		width,d0
	sub.w		#LCD_WIDTH-34,d0
	cmp.w		LCD_WIDTH,d0
	bgt		right_arrow

after_test_right_arrow:
	move.w		y,d0
	add.w		top,d0
	sub.w		#LCD_HEIGHT-50,d0
	cmp.w		LCD_HEIGHT,d0
	bgt		down_arrow

after_test_down_arrow:
wait_for_key:
	jsr		doorsos::ngetchx
	cmp.w		#$D,d0
	beq		quit
	cmp.w		#$108,d0
	beq		quit

	cmp.w		#KEY_LEFT,d0
	bne		is_key_right
	btst.b		#1,what_to_do
	beq		wait_for_key
	add.w		#8,x
	bra		loop

is_key_right:
	cmp.w		#KEY_RIGHT,d0
	bne		is_key_up
	btst.b		#0,what_to_do
	beq		wait_for_key
	sub.w		#8,x
	bra		loop

is_key_up:
	cmp.w		#KEY_UP,d0
	bne		is_key_down
	btst.b		#3,what_to_do
	beq		wait_for_key
	add.w		#8,y
	bra		loop

is_key_down:
	cmp.w		#KEY_DOWN,d0
	bne		is_right_left
	btst.b		#2,what_to_do
	beq		wait_for_key
	sub.w		#8,y
	bra		loop

is_right_left:
	cmp.w		#KEY_LEFT+16384,d0
	bne		is_right_right
	btst.b		#1,what_to_do
	beq		wait_for_key
	clr.w		x
	bra		loop

is_right_right:
	cmp.w		#KEY_RIGHT+16384,d0
	bne		is_right_up
	btst.b		#0,what_to_do
	beq		wait_for_key
	move.w		width,d0
	sub.w		#LCD_WIDTH,d0
	not.w		d0
	and.b		#$F8,d0
	move.w		d0,x
	bra		loop

is_right_up:
	cmp.w		#KEY_UP+16384,d0
	bne		is_right_down
	btst.b		#3,what_to_do
	beq		wait_for_key
	move.w		bottom,d0
	move.w		d0,y
	bra		loop

is_right_down:
	cmp.w		#KEY_DOWN+16384,d0
	bne		is_other
	btst.b		#2,what_to_do
	beq		wait_for_key
	move.w		#LCD_HEIGHT,d0
	sub.w		top,d0
	and.b		#$F8,d0
	move.w		bottom,d1
	and.w		#7,d1
	add.w		d1,d0
	sub.w		#8,d0
	move.w		d0,y
	bra		loop

is_other:
	bra		wait_for_key

quit:
	push.l		#window
	jsr		doorsos::WinClose
w_err:
	move.l		a6,a7
	move.l		d3,doorsos::top_estack
;	clr.w		handle
	rts

left_arrow:
	bset.b		#1,what_to_do
	clr.w		d0
	bsr		clr_col_d0
	move.w		#LCD_HEIGHT-2,d0
	lsr.l		#1,d0
	WriteStr	#0,d0,#color,left_str
	bra		after_test_left_arrow

right_arrow:
	bset.b		#0,what_to_do
	move.w		#LCD_WIDTH-6,d6
	move.w		d6,d0
	bsr		clr_col_d0
	move.w		#LCD_HEIGHT-2,d0
	lsr.l		#1,d0
	WriteStr	d6,d0,#color,right_str
	bra		after_test_right_arrow

up_arrow:
	bset.b		#3,what_to_do
	clr.w		d0
	bsr		clr_row_d0
	move.w		#LCD_WIDTH,d0
	lsr.w		#1,d0
	sub.w		#3,d0
	WriteStr	d0,#0,#color,up_str
	bra		after_test_up_arrow

down_arrow:
	bset.b		#2,what_to_do
	move.w		#LCD_HEIGHT-14,d0
	move.w		d0,d7
	bsr		clr_row_d0
	move.w		#LCD_WIDTH,d0
	lsr.w		#1,d0
	sub.w		#3,d0
	WriteStr	d0,d7,#color,down_str
	bra		after_test_down_arrow

clr_col_d0:
	move.w		#LCD_HEIGHT,d7
	lsr.w		#3,d7
	sub.w		#2,d7
	clr.w		d2
clr_col_next:
	movem.l	d0/d2,-(a7)
	WriteStr	d0,d2,#color,blank
	movem.l	(a7)+,d0/d2
	add.w		#8,d2
	dbf		d7,clr_col_next
	sub.w		#3,d2
	WriteStr	d0,d2,#color,blank
	rts

clr_row_d0:
	WriteStr	#0,d0,#color,width_str
	rts

;void Parms2D(ESI display_data,short *width,short *top,short *bottom);
;Print2DExpr(ESI display_data,WINDOW *window,short x,short y);

what_to_do	dc.b		0	;bit n0 = droite
					;	1 = gauche
					;	2 = bas
					;	3 = haut

rect		dc.w		0,0,LCD_WIDTH,LCD_HEIGHT-8
width		dc.w		0
top		dc.w		0
bottom		dc.w		0
y		dc.w		0	;y = bottom par dfaut
x		dc.w		0	;x = 0 par dfaut

right_str	dc.b		18,0
left_str	dc.b		17,0
down_str	dc.b		20,0
up_str		dc.b		19,0
blank		dc.b		" ",0

width_str	dcb.b		40,32
		dc.b		0

_comment	dc.b		"Unofficial ViewExpr by Cyril PASCAL",0

	BSS		; uninitialized data

window		ds.l		60

	end